using System;

namespace GameCore.TinyECS
{
    public struct ComponentId
    {
        struct Inner<T> where T : unmanaged
        {
            public int id;
            private Inner(int i) => id = i;
            public static Inner<T> Instance = default;
        }

        static int currentId;

        public static int Get<T>() where T : unmanaged
        {
            if (Inner<T>.Instance.id == 0)
            {
                Inner<T>.Instance.id = ++currentId;
            }
            return Inner<T>.Instance.id;
        }
    }
}